      SUBROUTINE QS19D(RINT,A,B,F,E,L,XA,XB,RA,RB,IERR)                 QS190010
         INTEGER IERR,L                                                 QS190020
         DOUBLE PRECISION A,B,E,F,RA,RB,RINT,XA,XB                      QS190030
         DIMENSION RA(L),RB(L),XA(L),XB(L)                              QS190040
         DOUBLE PRECISION DABS                                          QS190050
         EXTERNAL UTQS13                                                QS190060
         INTEGER I,I0,I1,K,K0,M,N                                       QS190070
         DOUBLE PRECISION C,E0,H,RA1,RA2,RB1,RB2,RI,X,X0,X1,
     *                    XA1,XA2,XB1,XB2                               QS190080
         DIMENSION C(16),X(16)                                          QS190090
         DATA X(1),X(2),X(3),X(4),X(5),X(6),X(7),X(8),X(9),X(10),       QS190100
     1   X(11),X(12),X(13),X(14),X(15),X(16)/.4986319309247408D0,       QS190110
     2   .4928057557726342D0,.4823811277937532D0,.4674530379688698D0,   QS190120
     3   .4481605778830261D0,.4246838068662850D0,.3972418979839712D0,   QS190130
     4   .3660910593701448D0,.3315221334651076D0,.2938578786203812D0,   QS190140
     5   .2534499544661147D0,.2106756380653177D0,.1659343011410638D0,   QS190150
     6   .1196436811260685D0,.0722359807913982D0,.0241538328438692D0/   QS190160                                  QS190160
         DATA C(1),C(2),C(3),C(4),C(5),C(6),C(7),C(8),C(9),C(10),       QS190170
     1   C(11),C(12),C(13),C(14),C(15),C(16)/.0035093050047350D0,       QS190180
     2   .0081371973654528D0,.0126960326546310D0,.0171369314565107D0,   QS190190
     3   .0214179490111133D0,.0254990296311881D0,.0293420467392678D0,   QS190200
     4   .0329111113881809D0,.0361728970544243D0,.0390969478935352D0,   QS190210
     5   .0416559621134734D0,.0438260465022019D0,.0455869393478819D0,   QS190220
     6   .0469221995404023D0,.0478193600396374D0,.0482700442573639D0/   QS190230
       N = L                                                            QS190240
       IERR = 0                                                         QS190250
       K = -1                                                           QS190260
       IF (A .NE. B) GO TO 10                                           QS190270
          RINT = 0.D0                                                   QS190280
          GO TO 140                                                     QS190290
   10  CONTINUE                                                         QS190300
       K = N                                                            QS190310
       XA1 = XA(1)                                                      QS190320
       XB1 = XB(1)                                                      QS190330
       H = XA(2) - XA1                                                  QS190340
       X1 = XA1 + .5D0*H                                                QS190350
       ASSIGN 20 TO M                                                   QS190360
       GO TO 110                                                        QS190370
   20  CONTINUE                                                         QS190380
       RA(1) = RI                                                       QS190390
       RA(2) = .5D0*RI                                                  QS190400
       RA1 = RI                                                         QS190410
       H = XB1 - XB(2)                                                  QS190420
       X1 = XB1 - .5D0*H                                                QS190430
       ASSIGN 30 TO M                                                   QS190440
       GO TO 110                                                        QS190450
   30  CONTINUE                                                         QS190460
       RB(1) = RI                                                       QS190470
       RB(2) = .5D0*RI                                                  QS190480
       RB1 = RI                                                         QS190490
       DO 70 I = 3, K                                                   QS190500
          K0 = I                                                        QS190510
          XA2 = XA(I)                                                   QS190520
          H = XA2 - XA(I-1)                                             QS190530
          X1 = XA2 - .5D0*H                                             QS190540
          ASSIGN 40 TO M                                                QS190550
          GO TO 110                                                     QS190560
   40     CONTINUE                                                      QS190570
          RA(1) = RA(1) + RI                                            QS190580
          RA(I) = RA(1)                                                 QS190590
          XB2 = XB(I)                                                   QS190600
          H = XB(I-1) - XB2                                             QS190610
          X1 = XB2 + .5D0*H                                             QS190620
          ASSIGN 50 TO M                                                QS190630
          GO TO 110                                                     QS190640
   50     CONTINUE                                                      QS190650
          RB(1) = RB(1) + RI                                            QS190660
          RB(I) = RB(1)                                                 QS190670
          DO 60 I1 = 2, I                                               QS190680
             I0 = I1                                                    QS190690
             RA2 = RA(I1)                                               QS190700
             RA(I1) = .5D0*(RA(I1-1) + RA1)                             QS190710
             RB2 = RB(I1)                                               QS190720
             RB(I1) = .5D0*(RB(I1-1) + RB1)                             QS190730
             E0 = DABS(RA(I1) - RA1) + DABS(RA(I1-1) - RA1) +           QS190740
     1            DABS(RB(I1) - RB1) + DABS(RB(I1-1) - RB1)             QS190750
             IF (E0 .LE. E) GO TO 80                                    QS190760
                RA1 = RA2                                               QS190770
                RB1 = RB2                                               QS190780
   60        CONTINUE                                                   QS190790
   70     CONTINUE                                                      QS190800
          IERR = 65                                                     QS190810
          CALL UTQS13(IERR,16)                                          QS190820
   80  CONTINUE                                                         QS190830
       RINT = RA(I0) + RB(I0)                                           QS190840
       K = K0                                                           QS190850
       H = XA1 - A                                                      QS190860
       IF (H .LE. 0.D0) GO TO 100                                       QS190870
          X1 = A + .5D0*H                                               QS190880
          ASSIGN 90 TO M                                                QS190890
          GO TO 110                                                     QS190900
   90  CONTINUE                                                         QS190910
       RINT = RINT + RI                                                 QS190920
  100  CONTINUE                                                         QS190930
       H = B - XB1                                                      QS190940
       IF (H .LE. 0.D0) GO TO 140                                       QS190950
          X1 = B - .5D0*H                                               QS190960
          ASSIGN 130 TO M                                               QS190970
  110  CONTINUE                                                         QS190980
       RI = 0.D0                                                        QS190990
       DO 120 I1 = 1, 16                                                QS191000
          X0 = H*X(I1)                                                  QS191010
          RI = RI + C(I1)*(F(X1+X0) + F(X1-X0))                         QS191020
  120  CONTINUE                                                         QS191030
       RI = H*RI                                                        QS191040
       GO TO M,(20,30,40,50,90,130)                                     QS191050
  130  CONTINUE                                                         QS191060
       RINT = RINT + RI                                                 QS191070
  140  CONTINUE                                                         QS191080
       RETURN                                                           QS191090
      END                                                               QS191100
